/* gkr-item.c generated by valac 0.56.17, the Vala compiler
 * generated from gkr-item.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2020 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-gkr.h"
#include <libsecret/secret.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define SEAHORSE_GKR_GENERIC_SECRET "org.freedesktop.Secret.Generic"
#define SEAHORSE_GKR_KEYRING_NOTE "org.gnome.keyring.Note"
#define SEAHORSE_GKR_CHAINED_KEYRING "org.gnome.keyring.ChainedKeyring"
#define SEAHORSE_GKR_ENCRYPTION_KEY "org.gnome.keyring.EncryptionKey"
#define SEAHORSE_GKR_PK_STORAGE "org.gnome.keyring.PkStorage"
#define SEAHORSE_GKR_NETWORK_MANAGER_SECRET "org.freedesktop.NetworkManager"
#define SEAHORSE_GKR_NETWORK_PASSWORD "org.gnome.keyring.NetworkPassword"
#define SEAHORSE_GKR_EPIPHANY_PASSWORD "x.internal.Epiphany"
#define SEAHORSE_GKR_CHROME_PASSWORD "x.internal.Chrome"
#define SEAHORSE_GKR_EDS_PASSWORD "org.gnome.Evolution.Data.Source"
#define SEAHORSE_GKR_GOA_PASSWORD "org.gnome.OnlineAccounts"
#define SEAHORSE_GKR_TELEPATHY_PASSWORD "org.freedesktop.Telepathy"
#define SEAHORSE_GKR_EMPATHY_PASSWORD "org.freedesktop.Empathy"
#define SEAHORSE_GKR_NETWORK_MANAGER_CONNECTION "org.freedesktop.NetworkManager.Connection"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_GKR_ITEM_0_PROPERTY,
	SEAHORSE_GKR_ITEM_DESCRIPTION_PROPERTY,
	SEAHORSE_GKR_ITEM_USE_PROPERTY,
	SEAHORSE_GKR_ITEM_HAS_SECRET_PROPERTY,
	SEAHORSE_GKR_ITEM_PLACE_PROPERTY,
	SEAHORSE_GKR_ITEM_OBJECT_FLAGS_PROPERTY,
	SEAHORSE_GKR_ITEM_ICON_PROPERTY,
	SEAHORSE_GKR_ITEM_LABEL_PROPERTY,
	SEAHORSE_GKR_ITEM_MARKUP_PROPERTY,
	SEAHORSE_GKR_ITEM_USAGE_PROPERTY,
	SEAHORSE_GKR_ITEM_DELETABLE_PROPERTY,
	SEAHORSE_GKR_ITEM_NUM_PROPERTIES
};
static GParamSpec* seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_NUM_PROPERTIES];
#define _secret_value_unref0(var) ((var == NULL) ? NULL : (var = (secret_value_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SEAHORSE_GKR_TYPE_ITEM_DELETER (seahorse_gkr_item_deleter_get_type ())
#define SEAHORSE_GKR_ITEM_DELETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_GKR_TYPE_ITEM_DELETER, SeahorseGkrItemDeleter))
#define SEAHORSE_GKR_ITEM_DELETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_GKR_TYPE_ITEM_DELETER, SeahorseGkrItemDeleterClass))
#define SEAHORSE_GKR_IS_ITEM_DELETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_GKR_TYPE_ITEM_DELETER))
#define SEAHORSE_GKR_IS_ITEM_DELETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_GKR_TYPE_ITEM_DELETER))
#define SEAHORSE_GKR_ITEM_DELETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_GKR_TYPE_ITEM_DELETER, SeahorseGkrItemDeleterClass))

typedef struct _SeahorseGkrItemDeleter SeahorseGkrItemDeleter;
typedef struct _SeahorseGkrItemDeleterClass SeahorseGkrItemDeleterClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _SeahorseGkrItemLoadItemSecretData SeahorseGkrItemLoadItemSecretData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SeahorseGkrItemSetSecretData SeahorseGkrItemSetSecretData;
typedef struct _SeahorseGkrItemCopySecretToClipboardData SeahorseGkrItemCopySecretToClipboardData;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define SEAHORSE_GKR_TYPE_MAPPING_ENTRY (seahorse_gkr_mapping_entry_get_type ())
typedef struct _SeahorseGkrMappingEntry SeahorseGkrMappingEntry;
typedef struct _SeahorseGkrItemDeleterPrivate SeahorseGkrItemDeleterPrivate;
enum  {
	SEAHORSE_GKR_ITEM_DELETER_0_PROPERTY,
	SEAHORSE_GKR_ITEM_DELETER_NUM_PROPERTIES
};
static GParamSpec* seahorse_gkr_item_deleter_properties[SEAHORSE_GKR_ITEM_DELETER_NUM_PROPERTIES];
typedef struct _SeahorseGkrItemDeleterDeleteData SeahorseGkrItemDeleterDeleteData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SeahorseGkrItemPrivate {
	SecretValue* _item_secret;
	SeahorseGkrItemInfo* _info;
	GWeakRef _place;
	GCancellable* _req_secret;
};

struct _SeahorseGkrItemLoadItemSecretData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseGkrItem* self;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	SecretValue* _tmp3_;
	GError* _inner_error0_;
};

struct _SeahorseGkrItemSetSecretData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseGkrItem* self;
	SecretValue* value;
	GCancellable* cancellable;
	gboolean result;
	SecretValue* _tmp0_;
	GError* _inner_error0_;
};

struct _SeahorseGkrItemCopySecretToClipboardData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseGkrItem* self;
	GtkClipboard* clipboard;
	SecretValue* _tmp0_;
	SecretValue* _tmp1_;
	const gchar* password;
	SecretValue* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

struct _SeahorseGkrMappingEntry {
	const gchar* item_type;
	const gchar* mapped_type;
	const gchar* match_attribute;
	const gchar* match_pattern;
};

struct _SeahorseGkrItemDeleter {
	SeahorseDeleter parent_instance;
	SeahorseGkrItemDeleterPrivate * priv;
};

struct _SeahorseGkrItemDeleterClass {
	SeahorseDeleterClass parent_class;
};

struct _SeahorseGkrItemDeleterPrivate {
	GList* _items;
};

struct _SeahorseGkrItemDeleterDeleteData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseGkrItemDeleter* self;
	GCancellable* cancellable;
	gboolean result;
	GList* items;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* item_collection;
	GList* item_it;
	SeahorseGkrItem* item;
	SeahorseGkrItem* _tmp3_;
	GError* _inner_error0_;
};

static gint SeahorseGkrItem_private_offset;
static gpointer seahorse_gkr_item_parent_class = NULL;
static SeahorseDeletableIface * seahorse_gkr_item_seahorse_deletable_parent_iface = NULL;
static SeahorseViewableIface * seahorse_gkr_item_seahorse_viewable_parent_iface = NULL;
static gint SeahorseGkrItemDeleter_private_offset;
static gpointer seahorse_gkr_item_deleter_parent_class = NULL;

static void seahorse_gkr_item_real_dispose (GObject* base);
static SeahorseDeleter* seahorse_gkr_item_real_create_deleter (SeahorseDeletable* base);
VALA_EXTERN SeahorseGkrItemDeleter* seahorse_gkr_item_deleter_new (SeahorseGkrItem* item);
VALA_EXTERN SeahorseGkrItemDeleter* seahorse_gkr_item_deleter_construct (GType object_type,
                                                             SeahorseGkrItem* item);
VALA_EXTERN GType seahorse_gkr_item_deleter_get_type (void) G_GNUC_CONST ;
static GtkWindow* seahorse_gkr_item_real_create_viewer (SeahorseViewable* base,
                                                 GtkWindow* parent);
static void seahorse_gkr_item_ensure_item_info (SeahorseGkrItem* self);
VALA_EXTERN const gchar* seahorse_gkr_map_item_type_to_specific (const gchar* item_type,
                                                     GHashTable* attrs);
static SeahorseGkrItemInfo* seahorse_gkr_item_item_type_to_item_info (SeahorseGkrItem* self,
                                                               const gchar* item_type,
                                                               const gchar* label,
                                                               GHashTable* attrs);
static void seahorse_gkr_item_load_item_secret_data_free (gpointer _data);
static void seahorse_gkr_item_load_item_secret (SeahorseGkrItem* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void seahorse_gkr_item_load_item_secret_finish (SeahorseGkrItem* self,
                                                GAsyncResult* _res_,
                                                GError** error);
static gboolean seahorse_gkr_item_load_item_secret_co (SeahorseGkrItemLoadItemSecretData* _data_);
static void seahorse_gkr_item_load_item_secret_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void __lambda6_ (SeahorseGkrItem* self,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda6__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void ___lambda8_ (SeahorseGkrItem* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda8__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void seahorse_gkr_item_set_secret_data_free (gpointer _data);
static gboolean seahorse_gkr_item_set_secret_co (SeahorseGkrItemSetSecretData* _data_);
static void seahorse_gkr_item_set_secret_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void seahorse_gkr_item_copy_secret_to_clipboard_data_free (gpointer _data);
static gboolean seahorse_gkr_item_copy_secret_to_clipboard_co (SeahorseGkrItemCopySecretToClipboardData* _data_);
static void seahorse_gkr_item_copy_secret_to_clipboard_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static GObject * seahorse_gkr_item_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _seahorse_gkr_item___lambda12_ (SeahorseGkrItem* self,
                                     GVariant* changed_properties,
                                     gchar** invalidated_properties);
static void __seahorse_gkr_item___lambda12__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                        GVariant* changed_properties,
                                                                        gchar** invalidated_properties,
                                                                        gpointer self);
static void seahorse_gkr_item_finalize (GObject * obj);
static GType seahorse_gkr_item_get_type_once (void);
static void _vala_seahorse_gkr_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_seahorse_gkr_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
VALA_EXTERN GType seahorse_gkr_mapping_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SeahorseGkrMappingEntry* seahorse_gkr_mapping_entry_dup (const SeahorseGkrMappingEntry* self);
VALA_EXTERN void seahorse_gkr_mapping_entry_free (SeahorseGkrMappingEntry* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GtkDialog* seahorse_gkr_item_deleter_real_create_confirm (SeahorseDeleter* base,
                                                          GtkWindow* parent);
static GList* seahorse_gkr_item_deleter_real_get_objects (SeahorseDeleter* base);
static gboolean seahorse_gkr_item_deleter_real_add_object (SeahorseDeleter* base,
                                                    GObject* obj);
static void seahorse_gkr_item_deleter_real_delete_data_free (gpointer _data);
static void seahorse_gkr_item_deleter_real_delete (SeahorseDeleter* base,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static gboolean seahorse_gkr_item_deleter_real_delete_co (SeahorseGkrItemDeleterDeleteData* _data_);
static void seahorse_gkr_item_deleter_delete_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void seahorse_gkr_item_deleter_finalize (GObject * obj);
static GType seahorse_gkr_item_deleter_get_type_once (void);

const SeahorseGkrMappingEntry SEAHORSE_GKR_MAPPING_ENTRIES[11] = {{"org.gnome.Polari.Identify", "org.gnome.Polari"}, {"org.remmina.Password", "org.remmina.Remmina"}, {"_chrome_dummy_schema_for_unlocking", "google-chrome"}, {"chrome_libsecret_os_crypt_password_v2", "chromium-browser"}, {"org.epiphany.FormPassword", SEAHORSE_GKR_EPIPHANY_PASSWORD}, {"chrome_libsecret_password_schema", SEAHORSE_GKR_CHROME_PASSWORD}, {SEAHORSE_GKR_GENERIC_SECRET, SEAHORSE_GKR_CHROME_PASSWORD, "application", "chrome*"}, {SEAHORSE_GKR_GENERIC_SECRET, SEAHORSE_GKR_GOA_PASSWORD, "goa-identity", NULL}, {SEAHORSE_GKR_GENERIC_SECRET, SEAHORSE_GKR_TELEPATHY_PASSWORD, "account", "*/*/*"}, {SEAHORSE_GKR_GENERIC_SECRET, SEAHORSE_GKR_EMPATHY_PASSWORD, "account-id", "*/*/*"}, {SEAHORSE_GKR_GENERIC_SECRET, SEAHORSE_GKR_NETWORK_MANAGER_SECRET, "connection-uuid", NULL}};

 G_GNUC_NO_INLINE static GType
seahorse_gkr_use_get_type_once (void)
{
	static const GEnumValue values[] = {{SEAHORSE_GKR_USE_OTHER, "SEAHORSE_GKR_USE_OTHER", "other"}, {SEAHORSE_GKR_USE_NETWORK, "SEAHORSE_GKR_USE_NETWORK", "network"}, {SEAHORSE_GKR_USE_WEB, "SEAHORSE_GKR_USE_WEB", "web"}, {SEAHORSE_GKR_USE_PGP, "SEAHORSE_GKR_USE_PGP", "pgp"}, {SEAHORSE_GKR_USE_SSH, "SEAHORSE_GKR_USE_SSH", "ssh"}, {0, NULL, NULL}};
	GType seahorse_gkr_use_type_id;
	seahorse_gkr_use_type_id = g_enum_register_static ("SeahorseGkrUse", values);
	return seahorse_gkr_use_type_id;
}

GType
seahorse_gkr_use_get_type (void)
{
	static volatile gsize seahorse_gkr_use_type_id__once = 0;
	if (g_once_init_enter (&seahorse_gkr_use_type_id__once)) {
		GType seahorse_gkr_use_type_id;
		seahorse_gkr_use_type_id = seahorse_gkr_use_get_type_once ();
		g_once_init_leave (&seahorse_gkr_use_type_id__once, seahorse_gkr_use_type_id);
	}
	return seahorse_gkr_use_type_id__once;
}

static inline gpointer
seahorse_gkr_item_get_instance_private (SeahorseGkrItem* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseGkrItem_private_offset);
}

static void
seahorse_gkr_item_real_dispose (GObject* base)
{
	SeahorseGkrItem * self;
	GCancellable* _tmp0_;
#line 125 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItem*) base;
#line 126 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_req_secret;
#line 126 "../gkr/gkr-item.vala"
	if (_tmp0_ != NULL) {
#line 334 "gkr-item.c"
		GCancellable* _tmp1_;
#line 127 "../gkr/gkr-item.vala"
		_tmp1_ = self->priv->_req_secret;
#line 127 "../gkr/gkr-item.vala"
		g_cancellable_cancel (_tmp1_);
#line 340 "gkr-item.c"
	}
#line 128 "../gkr/gkr-item.vala"
	_g_object_unref0 (self->priv->_req_secret);
#line 128 "../gkr/gkr-item.vala"
	self->priv->_req_secret = NULL;
#line 129 "../gkr/gkr-item.vala"
	G_OBJECT_CLASS (seahorse_gkr_item_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, secret_item_get_type (), SecretItem));
#line 348 "gkr-item.c"
}

static SeahorseDeleter*
seahorse_gkr_item_real_create_deleter (SeahorseDeletable* base)
{
	SeahorseGkrItem * self;
	SeahorseGkrItemDeleter* _tmp0_;
	SeahorseDeleter* result;
#line 132 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItem*) base;
#line 133 "../gkr/gkr-item.vala"
	_tmp0_ = seahorse_gkr_item_deleter_new (self);
#line 133 "../gkr/gkr-item.vala"
	result = (SeahorseDeleter*) _tmp0_;
#line 133 "../gkr/gkr-item.vala"
	return result;
#line 365 "gkr-item.c"
}

static GtkWindow*
seahorse_gkr_item_real_create_viewer (SeahorseViewable* base,
                                      GtkWindow* parent)
{
	SeahorseGkrItem * self;
	SeahorseGkrItemProperties* _tmp0_;
	GtkWindow* result;
#line 136 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItem*) base;
#line 137 "../gkr/gkr-item.vala"
	_tmp0_ = seahorse_gkr_item_properties_new (self, parent);
#line 137 "../gkr/gkr-item.vala"
	g_object_ref_sink (_tmp0_);
#line 137 "../gkr/gkr-item.vala"
	result = (GtkWindow*) _tmp0_;
#line 137 "../gkr/gkr-item.vala"
	return result;
#line 385 "gkr-item.c"
}

static void
seahorse_gkr_item_ensure_item_info (SeahorseGkrItem* self)
{
	SeahorseGkrItemInfo* _tmp0_;
	const gchar* item_type = NULL;
	GHashTable* attrs = NULL;
	GHashTable* _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	const gchar* _tmp6_;
	GHashTable* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* label = NULL;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GHashTable* _tmp13_;
	SeahorseGkrItemInfo* _tmp14_;
	SeahorseGkrItemInfo* _tmp15_;
	GIcon* _tmp16_;
	GIcon* _tmp17_;
#line 140 "../gkr/gkr-item.vala"
	g_return_if_fail (self != NULL);
#line 141 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_info;
#line 141 "../gkr/gkr-item.vala"
	if (_tmp0_ != NULL) {
#line 142 "../gkr/gkr-item.vala"
		return;
#line 418 "gkr-item.c"
	}
#line 144 "../gkr/gkr-item.vala"
	item_type = NULL;
#line 145 "../gkr/gkr-item.vala"
	g_object_get ((SecretRetrievable*) self, "attributes", &_tmp1_, NULL);
#line 145 "../gkr/gkr-item.vala"
	_tmp2_ = _tmp1_;
#line 145 "../gkr/gkr-item.vala"
	attrs = _tmp2_;
#line 146 "../gkr/gkr-item.vala"
	_tmp3_ = attrs;
#line 146 "../gkr/gkr-item.vala"
	if (_tmp3_ != NULL) {
#line 432 "gkr-item.c"
		GHashTable* _tmp4_;
		gconstpointer _tmp5_;
#line 147 "../gkr/gkr-item.vala"
		_tmp4_ = attrs;
#line 147 "../gkr/gkr-item.vala"
		_tmp5_ = g_hash_table_lookup (_tmp4_, "xdg:schema");
#line 147 "../gkr/gkr-item.vala"
		item_type = (const gchar*) _tmp5_;
#line 441 "gkr-item.c"
	}
#line 148 "../gkr/gkr-item.vala"
	_tmp6_ = item_type;
#line 148 "../gkr/gkr-item.vala"
	_tmp7_ = attrs;
#line 148 "../gkr/gkr-item.vala"
	_tmp8_ = seahorse_gkr_map_item_type_to_specific (_tmp6_, _tmp7_);
#line 148 "../gkr/gkr-item.vala"
	item_type = _tmp8_;
#line 149 "../gkr/gkr-item.vala"
	_tmp9_ = item_type;
#line 149 "../gkr/gkr-item.vala"
	_vala_assert (_tmp9_ != NULL, "item_type != null");
#line 151 "../gkr/gkr-item.vala"
	_tmp10_ = secret_item_get_label (G_TYPE_CHECK_INSTANCE_CAST (self, secret_item_get_type (), SecretItem));
#line 151 "../gkr/gkr-item.vala"
	label = _tmp10_;
#line 153 "../gkr/gkr-item.vala"
	_tmp11_ = item_type;
#line 153 "../gkr/gkr-item.vala"
	_tmp12_ = label;
#line 153 "../gkr/gkr-item.vala"
	_tmp13_ = attrs;
#line 153 "../gkr/gkr-item.vala"
	_tmp14_ = seahorse_gkr_item_item_type_to_item_info (self, _tmp11_, _tmp12_, _tmp13_);
#line 153 "../gkr/gkr-item.vala"
	_g_object_unref0 (self->priv->_info);
#line 153 "../gkr/gkr-item.vala"
	self->priv->_info = _tmp14_;
#line 156 "../gkr/gkr-item.vala"
	_tmp15_ = self->priv->_info;
#line 156 "../gkr/gkr-item.vala"
	_tmp16_ = seahorse_gkr_item_info_get_icon (_tmp15_);
#line 156 "../gkr/gkr-item.vala"
	_tmp17_ = _tmp16_;
#line 156 "../gkr/gkr-item.vala"
	if (_tmp17_ == NULL) {
#line 479 "gkr-item.c"
		SeahorseGkrItemInfo* _tmp18_;
		const gchar* _tmp19_;
#line 157 "../gkr/gkr-item.vala"
		_tmp18_ = self->priv->_info;
#line 157 "../gkr/gkr-item.vala"
		_tmp19_ = item_type;
#line 157 "../gkr/gkr-item.vala"
		seahorse_gkr_item_info_query_installed_apps (_tmp18_, _tmp19_);
#line 488 "gkr-item.c"
	}
#line 140 "../gkr/gkr-item.vala"
	_g_free0 (label);
#line 140 "../gkr/gkr-item.vala"
	_g_hash_table_unref0 (attrs);
#line 494 "gkr-item.c"
}

static SeahorseGkrItemInfo*
seahorse_gkr_item_item_type_to_item_info (SeahorseGkrItem* self,
                                          const gchar* item_type,
                                          const gchar* label,
                                          GHashTable* attrs)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label0 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label1 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label2 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label3 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label4 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label5 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label6 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label7 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label8 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label9 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label10 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label11 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label12 = 0;
#line 161 "../gkr/gkr-item.vala"
	static GQuark _tmp1_label13 = 0;
#line 533 "gkr-item.c"
	SeahorseGkrItemInfo* _tmp17_;
	SeahorseGkrItemInfo* result;
#line 160 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "../gkr/gkr-item.vala"
	g_return_val_if_fail (item_type != NULL, NULL);
#line 161 "../gkr/gkr-item.vala"
	_tmp0_ = item_type;
#line 161 "../gkr/gkr-item.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 161 "../gkr/gkr-item.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (SEAHORSE_GKR_GENERIC_SECRET)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 548 "gkr-item.c"
			default:
			{
				SeahorseGkrItemInfo* _tmp3_;
#line 163 "../gkr/gkr-item.vala"
				_tmp3_ = seahorse_gkr_item_info_new (label, attrs, NULL);
#line 163 "../gkr/gkr-item.vala"
				result = _tmp3_;
#line 163 "../gkr/gkr-item.vala"
				return result;
#line 558 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (SEAHORSE_GKR_KEYRING_NOTE)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 564 "gkr-item.c"
			default:
			{
				SeahorseGkrItemInfo* _tmp4_;
#line 165 "../gkr/gkr-item.vala"
				_tmp4_ = seahorse_gkr_item_info_new (label, attrs, _ ("Stored note"));
#line 165 "../gkr/gkr-item.vala"
				result = _tmp4_;
#line 165 "../gkr/gkr-item.vala"
				return result;
#line 574 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string (SEAHORSE_GKR_CHAINED_KEYRING)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 580 "gkr-item.c"
			default:
			{
				SeahorseGkrItemInfo* _tmp5_;
#line 167 "../gkr/gkr-item.vala"
				_tmp5_ = seahorse_gkr_item_info_new (label, attrs, _ ("Keyring password"));
#line 167 "../gkr/gkr-item.vala"
				result = _tmp5_;
#line 167 "../gkr/gkr-item.vala"
				return result;
#line 590 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string (SEAHORSE_GKR_ENCRYPTION_KEY)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 596 "gkr-item.c"
			default:
			{
				SeahorseGkrItemInfo* _tmp6_;
#line 169 "../gkr/gkr-item.vala"
				_tmp6_ = seahorse_gkr_item_info_new (label, attrs, _ ("Encryption key password"));
#line 169 "../gkr/gkr-item.vala"
				result = _tmp6_;
#line 169 "../gkr/gkr-item.vala"
				return result;
#line 606 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string (SEAHORSE_GKR_PK_STORAGE)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 612 "gkr-item.c"
			default:
			{
				SeahorseGkrItemInfo* _tmp7_;
#line 171 "../gkr/gkr-item.vala"
				_tmp7_ = seahorse_gkr_item_info_new (label, attrs, _ ("Key storage password"));
#line 171 "../gkr/gkr-item.vala"
				result = _tmp7_;
#line 171 "../gkr/gkr-item.vala"
				return result;
#line 622 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string (SEAHORSE_GKR_NETWORK_MANAGER_SECRET)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 628 "gkr-item.c"
			default:
			{
				SeahorseGkrItemInfo* _tmp8_;
#line 173 "../gkr/gkr-item.vala"
				_tmp8_ = seahorse_gkr_item_info_new (label, attrs, _ ("Network Manager secret"));
#line 173 "../gkr/gkr-item.vala"
				result = _tmp8_;
#line 173 "../gkr/gkr-item.vala"
				return result;
#line 638 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string (SEAHORSE_GKR_NETWORK_PASSWORD)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 644 "gkr-item.c"
			default:
			{
				SeahorseGkrGkrNetworkPassInfo* _tmp9_;
#line 175 "../gkr/gkr-item.vala"
				_tmp9_ = seahorse_gkr_gkr_network_pass_info_new (label, attrs);
#line 175 "../gkr/gkr-item.vala"
				result = (SeahorseGkrItemInfo*) _tmp9_;
#line 175 "../gkr/gkr-item.vala"
				return result;
#line 654 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string (SEAHORSE_GKR_EPIPHANY_PASSWORD)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 660 "gkr-item.c"
			default:
			{
				SeahorseGkrEpiphanyPassInfo* _tmp10_;
#line 177 "../gkr/gkr-item.vala"
				_tmp10_ = seahorse_gkr_epiphany_pass_info_new (label, attrs);
#line 177 "../gkr/gkr-item.vala"
				result = (SeahorseGkrItemInfo*) _tmp10_;
#line 177 "../gkr/gkr-item.vala"
				return result;
#line 670 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string (SEAHORSE_GKR_CHROME_PASSWORD)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 676 "gkr-item.c"
			default:
			{
				SeahorseGkrChromePassInfo* _tmp11_;
#line 179 "../gkr/gkr-item.vala"
				_tmp11_ = seahorse_gkr_chrome_pass_info_new (label, attrs);
#line 179 "../gkr/gkr-item.vala"
				result = (SeahorseGkrItemInfo*) _tmp11_;
#line 179 "../gkr/gkr-item.vala"
				return result;
#line 686 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string (SEAHORSE_GKR_EDS_PASSWORD)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 692 "gkr-item.c"
			default:
			{
				SeahorseGkrEdsPassInfo* _tmp12_;
#line 181 "../gkr/gkr-item.vala"
				_tmp12_ = seahorse_gkr_eds_pass_info_new (label, attrs);
#line 181 "../gkr/gkr-item.vala"
				result = (SeahorseGkrItemInfo*) _tmp12_;
#line 181 "../gkr/gkr-item.vala"
				return result;
#line 702 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string (SEAHORSE_GKR_GOA_PASSWORD)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 708 "gkr-item.c"
			default:
			{
				SeahorseGkrGoaInfo* _tmp13_;
#line 183 "../gkr/gkr-item.vala"
				_tmp13_ = seahorse_gkr_goa_info_new (label, attrs);
#line 183 "../gkr/gkr-item.vala"
				result = (SeahorseGkrItemInfo*) _tmp13_;
#line 183 "../gkr/gkr-item.vala"
				return result;
#line 718 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string (SEAHORSE_GKR_TELEPATHY_PASSWORD)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 724 "gkr-item.c"
			default:
			{
				SeahorseGkrTelepathyInfo* _tmp14_;
#line 185 "../gkr/gkr-item.vala"
				_tmp14_ = seahorse_gkr_telepathy_info_new (label, attrs);
#line 185 "../gkr/gkr-item.vala"
				result = (SeahorseGkrItemInfo*) _tmp14_;
#line 185 "../gkr/gkr-item.vala"
				return result;
#line 734 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string (SEAHORSE_GKR_EMPATHY_PASSWORD)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 740 "gkr-item.c"
			default:
			{
				SeahorseGkrEmpathyInfo* _tmp15_;
#line 187 "../gkr/gkr-item.vala"
				_tmp15_ = seahorse_gkr_empathy_info_new (label, attrs);
#line 187 "../gkr/gkr-item.vala"
				result = (SeahorseGkrItemInfo*) _tmp15_;
#line 187 "../gkr/gkr-item.vala"
				return result;
#line 750 "gkr-item.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string (SEAHORSE_GKR_NETWORK_MANAGER_CONNECTION)))) {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 756 "gkr-item.c"
			default:
			{
				SeahorseGkrNmConnectionInfo* _tmp16_;
#line 189 "../gkr/gkr-item.vala"
				_tmp16_ = seahorse_gkr_nm_connection_info_new (label, attrs);
#line 189 "../gkr/gkr-item.vala"
				result = (SeahorseGkrItemInfo*) _tmp16_;
#line 189 "../gkr/gkr-item.vala"
				return result;
#line 766 "gkr-item.c"
			}
		}
	} else {
#line 161 "../gkr/gkr-item.vala"
		switch (0) {
#line 772 "gkr-item.c"
			default:
			{
#line 191 "../gkr/gkr-item.vala"
				break;
#line 777 "gkr-item.c"
			}
		}
	}
#line 194 "../gkr/gkr-item.vala"
	_tmp17_ = seahorse_gkr_item_info_new (label, attrs, NULL);
#line 194 "../gkr/gkr-item.vala"
	result = _tmp17_;
#line 194 "../gkr/gkr-item.vala"
	return result;
#line 787 "gkr-item.c"
}

static void
seahorse_gkr_item_load_item_secret_data_free (gpointer _data)
{
	SeahorseGkrItemLoadItemSecretData* _data_;
	_data_ = _data;
#line 38 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../gkr/gkr-item.vala"
	g_slice_free (SeahorseGkrItemLoadItemSecretData, _data_);
#line 799 "gkr-item.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../gkr/gkr-item.vala"
	return self ? g_object_ref (self) : NULL;
#line 807 "gkr-item.c"
}

static void
seahorse_gkr_item_load_item_secret (SeahorseGkrItem* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	SeahorseGkrItemLoadItemSecretData* _data_;
	SeahorseGkrItem* _tmp0_;
#line 38 "../gkr/gkr-item.vala"
	g_return_if_fail (self != NULL);
#line 38 "../gkr/gkr-item.vala"
	_data_ = g_slice_new0 (SeahorseGkrItemLoadItemSecretData);
#line 38 "../gkr/gkr-item.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../gkr/gkr-item.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_gkr_item_load_item_secret_data_free);
#line 38 "../gkr/gkr-item.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../gkr/gkr-item.vala"
	_data_->self = _tmp0_;
#line 38 "../gkr/gkr-item.vala"
	seahorse_gkr_item_load_item_secret_co (_data_);
#line 831 "gkr-item.c"
}

static void
seahorse_gkr_item_load_item_secret_finish (SeahorseGkrItem* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	SeahorseGkrItemLoadItemSecretData* _data_;
#line 38 "../gkr/gkr-item.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 38 "../gkr/gkr-item.vala"
	if (NULL == _data_) {
#line 38 "../gkr/gkr-item.vala"
		return;
#line 846 "gkr-item.c"
	}
}

static void
seahorse_gkr_item_load_item_secret_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	SeahorseGkrItemLoadItemSecretData* _data_;
#line 203 "../gkr/gkr-item.vala"
	_data_ = _user_data_;
#line 203 "../gkr/gkr-item.vala"
	_data_->_source_object_ = source_object;
#line 203 "../gkr/gkr-item.vala"
	_data_->_res_ = _res_;
#line 203 "../gkr/gkr-item.vala"
	seahorse_gkr_item_load_item_secret_co (_data_);
#line 864 "gkr-item.c"
}

static gboolean
seahorse_gkr_item_load_item_secret_co (SeahorseGkrItemLoadItemSecretData* _data_)
{
#line 197 "../gkr/gkr-item.vala"
	switch (_data_->_state_) {
#line 197 "../gkr/gkr-item.vala"
		case 0:
#line 874 "gkr-item.c"
		goto _state_0;
#line 197 "../gkr/gkr-item.vala"
		case 1:
#line 878 "gkr-item.c"
		goto _state_1;
		default:
#line 197 "../gkr/gkr-item.vala"
		g_assert_not_reached ();
#line 883 "gkr-item.c"
	}
	_state_0:
#line 198 "../gkr/gkr-item.vala"
	_data_->_tmp0_ = _data_->self->priv->_req_secret;
#line 198 "../gkr/gkr-item.vala"
	if (_data_->_tmp0_ != NULL) {
#line 199 "../gkr/gkr-item.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 199 "../gkr/gkr-item.vala"
		if (_data_->_state_ != 0) {
#line 199 "../gkr/gkr-item.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 199 "../gkr/gkr-item.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 898 "gkr-item.c"
			}
		}
#line 199 "../gkr/gkr-item.vala"
		g_object_unref (_data_->_async_result);
#line 199 "../gkr/gkr-item.vala"
		return FALSE;
#line 905 "gkr-item.c"
	}
#line 201 "../gkr/gkr-item.vala"
	_data_->_tmp1_ = g_cancellable_new ();
#line 201 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->self->priv->_req_secret);
#line 201 "../gkr/gkr-item.vala"
	_data_->self->priv->_req_secret = _data_->_tmp1_;
#line 203 "../gkr/gkr-item.vala"
	_data_->_tmp2_ = _data_->self->priv->_req_secret;
#line 203 "../gkr/gkr-item.vala"
	_data_->_state_ = 1;
#line 203 "../gkr/gkr-item.vala"
	secret_item_load_secret ((SecretItem*) _data_->self, _data_->_tmp2_, seahorse_gkr_item_load_item_secret_ready, _data_);
#line 203 "../gkr/gkr-item.vala"
	return FALSE;
#line 921 "gkr-item.c"
	_state_1:
#line 203 "../gkr/gkr-item.vala"
	secret_item_load_secret_finish ((SecretItem*) _data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 203 "../gkr/gkr-item.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 203 "../gkr/gkr-item.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 203 "../gkr/gkr-item.vala"
		g_object_unref (_data_->_async_result);
#line 203 "../gkr/gkr-item.vala"
		return FALSE;
#line 933 "gkr-item.c"
	}
#line 204 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->self->priv->_req_secret);
#line 204 "../gkr/gkr-item.vala"
	_data_->self->priv->_req_secret = NULL;
#line 205 "../gkr/gkr-item.vala"
	_data_->_tmp3_ = secret_item_get_secret (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, secret_item_get_type (), SecretItem));
#line 205 "../gkr/gkr-item.vala"
	_secret_value_unref0 (_data_->self->priv->_item_secret);
#line 205 "../gkr/gkr-item.vala"
	_data_->self->priv->_item_secret = _data_->_tmp3_;
#line 206 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) _data_->self, "has-secret");
#line 197 "../gkr/gkr-item.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 197 "../gkr/gkr-item.vala"
	if (_data_->_state_ != 0) {
#line 197 "../gkr/gkr-item.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 197 "../gkr/gkr-item.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 955 "gkr-item.c"
		}
	}
#line 197 "../gkr/gkr-item.vala"
	g_object_unref (_data_->_async_result);
#line 197 "../gkr/gkr-item.vala"
	return FALSE;
#line 962 "gkr-item.c"
}

static void
__lambda6_ (SeahorseGkrItem* self,
            GObject* obj,
            GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 215 "../gkr/gkr-item.vala"
	g_return_if_fail (res != NULL);
#line 973 "gkr-item.c"
	{
#line 217 "../gkr/gkr-item.vala"
		seahorse_gkr_item_load_item_secret_finish (self, res, &_inner_error0_);
#line 217 "../gkr/gkr-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 979 "gkr-item.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 216 "../gkr/gkr-item.vala"
		e = _inner_error0_;
#line 216 "../gkr/gkr-item.vala"
		_inner_error0_ = NULL;
#line 219 "../gkr/gkr-item.vala"
		_tmp0_ = e;
#line 219 "../gkr/gkr-item.vala"
		_tmp1_ = _tmp0_->message;
#line 219 "../gkr/gkr-item.vala"
		g_warning ("gkr-item.vala:219: Couldn't load secret: %s", _tmp1_);
#line 216 "../gkr/gkr-item.vala"
		_g_error_free0 (e);
#line 1001 "gkr-item.c"
	}
	__finally0:
#line 216 "../gkr/gkr-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../gkr/gkr-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "../gkr/gkr-item.vala"
		g_clear_error (&_inner_error0_);
#line 216 "../gkr/gkr-item.vala"
		return;
#line 1012 "gkr-item.c"
	}
}

static void
___lambda6__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 215 "../gkr/gkr-item.vala"
	__lambda6_ ((SeahorseGkrItem*) self, source_object, res);
#line 215 "../gkr/gkr-item.vala"
	g_object_unref (self);
#line 1025 "gkr-item.c"
}

void
seahorse_gkr_item_refresh (SeahorseGkrItem* self)
{
	SecretValue* _tmp0_;
#line 209 "../gkr/gkr-item.vala"
	g_return_if_fail (self != NULL);
#line 210 "../gkr/gkr-item.vala"
	secret_item_refresh (G_TYPE_CHECK_INSTANCE_CAST (self, secret_item_get_type (), SecretItem));
#line 212 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_item_secret;
#line 212 "../gkr/gkr-item.vala"
	if (_tmp0_ != NULL) {
#line 213 "../gkr/gkr-item.vala"
		return;
#line 1042 "gkr-item.c"
	}
#line 215 "../gkr/gkr-item.vala"
	seahorse_gkr_item_load_item_secret (self, ___lambda6__gasync_ready_callback, g_object_ref (self));
#line 1046 "gkr-item.c"
}

static void
___lambda8_ (SeahorseGkrItem* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 226 "../gkr/gkr-item.vala"
	g_return_if_fail (res != NULL);
#line 1057 "gkr-item.c"
	{
#line 228 "../gkr/gkr-item.vala"
		seahorse_gkr_item_load_item_secret_finish (self, res, &_inner_error0_);
#line 228 "../gkr/gkr-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1063 "gkr-item.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 227 "../gkr/gkr-item.vala"
		e = _inner_error0_;
#line 227 "../gkr/gkr-item.vala"
		_inner_error0_ = NULL;
#line 230 "../gkr/gkr-item.vala"
		_tmp0_ = e;
#line 230 "../gkr/gkr-item.vala"
		_tmp1_ = _tmp0_->message;
#line 230 "../gkr/gkr-item.vala"
		g_warning ("gkr-item.vala:230: Couldn't load secret: %s", _tmp1_);
#line 227 "../gkr/gkr-item.vala"
		_g_error_free0 (e);
#line 1085 "gkr-item.c"
	}
	__finally0:
#line 227 "../gkr/gkr-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "../gkr/gkr-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 227 "../gkr/gkr-item.vala"
		g_clear_error (&_inner_error0_);
#line 227 "../gkr/gkr-item.vala"
		return;
#line 1096 "gkr-item.c"
	}
}

static void
____lambda8__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 226 "../gkr/gkr-item.vala"
	___lambda8_ ((SeahorseGkrItem*) self, source_object, res);
#line 226 "../gkr/gkr-item.vala"
	g_object_unref (self);
#line 1109 "gkr-item.c"
}

static gpointer
_secret_value_ref0 (gpointer self)
{
#line 234 "../gkr/gkr-item.vala"
	return self ? secret_value_ref (self) : NULL;
#line 1117 "gkr-item.c"
}

SecretValue*
seahorse_gkr_item_get_secret (SeahorseGkrItem* self)
{
	SecretValue* _tmp0_;
	SecretValue* _tmp1_;
	SecretValue* _tmp2_;
	SecretValue* result;
#line 224 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 225 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_item_secret;
#line 225 "../gkr/gkr-item.vala"
	if (_tmp0_ == NULL) {
#line 226 "../gkr/gkr-item.vala"
		seahorse_gkr_item_load_item_secret (self, ____lambda8__gasync_ready_callback, g_object_ref (self));
#line 1135 "gkr-item.c"
	}
#line 234 "../gkr/gkr-item.vala"
	_tmp1_ = self->priv->_item_secret;
#line 234 "../gkr/gkr-item.vala"
	_tmp2_ = _secret_value_ref0 (_tmp1_);
#line 234 "../gkr/gkr-item.vala"
	result = _tmp2_;
#line 234 "../gkr/gkr-item.vala"
	return result;
#line 1145 "gkr-item.c"
}

gchar*
seahorse_gkr_item_get_attribute (SeahorseGkrItem* self,
                                 const gchar* name)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GHashTable* _tmp2_;
	gboolean _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	GHashTable* _tmp6_;
	gconstpointer _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 237 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 237 "../gkr/gkr-item.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 238 "../gkr/gkr-item.vala"
	g_object_get ((SecretRetrievable*) self, "attributes", &_tmp0_, NULL);
#line 238 "../gkr/gkr-item.vala"
	_tmp1_ = _tmp0_;
#line 238 "../gkr/gkr-item.vala"
	_tmp2_ = _tmp1_;
#line 238 "../gkr/gkr-item.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 238 "../gkr/gkr-item.vala"
	_g_hash_table_unref0 (_tmp2_);
#line 238 "../gkr/gkr-item.vala"
	if (_tmp3_) {
#line 239 "../gkr/gkr-item.vala"
		result = NULL;
#line 239 "../gkr/gkr-item.vala"
		return result;
#line 1183 "gkr-item.c"
	}
#line 240 "../gkr/gkr-item.vala"
	g_object_get ((SecretRetrievable*) self, "attributes", &_tmp4_, NULL);
#line 240 "../gkr/gkr-item.vala"
	_tmp5_ = _tmp4_;
#line 240 "../gkr/gkr-item.vala"
	_tmp6_ = _tmp5_;
#line 240 "../gkr/gkr-item.vala"
	_tmp7_ = g_hash_table_lookup (_tmp6_, name);
#line 240 "../gkr/gkr-item.vala"
	_tmp8_ = g_strdup ((const gchar*) _tmp7_);
#line 240 "../gkr/gkr-item.vala"
	_tmp9_ = _tmp8_;
#line 240 "../gkr/gkr-item.vala"
	_g_hash_table_unref0 (_tmp6_);
#line 240 "../gkr/gkr-item.vala"
	result = _tmp9_;
#line 240 "../gkr/gkr-item.vala"
	return result;
#line 1203 "gkr-item.c"
}

static void
seahorse_gkr_item_set_secret_data_free (gpointer _data)
{
	SeahorseGkrItemSetSecretData* _data_;
	_data_ = _data;
#line 38 "../gkr/gkr-item.vala"
	_secret_value_unref0 (_data_->value);
#line 38 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->cancellable);
#line 38 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../gkr/gkr-item.vala"
	g_slice_free (SeahorseGkrItemSetSecretData, _data_);
#line 1219 "gkr-item.c"
}

void
seahorse_gkr_item_set_secret (SeahorseGkrItem* self,
                              SecretValue* value,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	SeahorseGkrItemSetSecretData* _data_;
	SeahorseGkrItem* _tmp0_;
	SecretValue* _tmp1_;
	GCancellable* _tmp2_;
#line 38 "../gkr/gkr-item.vala"
	g_return_if_fail (self != NULL);
#line 38 "../gkr/gkr-item.vala"
	g_return_if_fail (value != NULL);
#line 38 "../gkr/gkr-item.vala"
	_data_ = g_slice_new0 (SeahorseGkrItemSetSecretData);
#line 38 "../gkr/gkr-item.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 38 "../gkr/gkr-item.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_gkr_item_set_secret_data_free);
#line 38 "../gkr/gkr-item.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../gkr/gkr-item.vala"
	_data_->self = _tmp0_;
#line 38 "../gkr/gkr-item.vala"
	_tmp1_ = _secret_value_ref0 (value);
#line 38 "../gkr/gkr-item.vala"
	_secret_value_unref0 (_data_->value);
#line 38 "../gkr/gkr-item.vala"
	_data_->value = _tmp1_;
#line 38 "../gkr/gkr-item.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 38 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->cancellable);
#line 38 "../gkr/gkr-item.vala"
	_data_->cancellable = _tmp2_;
#line 38 "../gkr/gkr-item.vala"
	seahorse_gkr_item_set_secret_co (_data_);
#line 1261 "gkr-item.c"
}

gboolean
seahorse_gkr_item_set_secret_finish (SeahorseGkrItem* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	gboolean result;
	SeahorseGkrItemSetSecretData* _data_;
#line 38 "../gkr/gkr-item.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 38 "../gkr/gkr-item.vala"
	if (NULL == _data_) {
#line 1275 "gkr-item.c"
		gboolean _tmp0_ = FALSE;
#line 38 "../gkr/gkr-item.vala"
		return _tmp0_;
#line 1279 "gkr-item.c"
	}
#line 38 "../gkr/gkr-item.vala"
	result = _data_->result;
#line 38 "../gkr/gkr-item.vala"
	return result;
#line 1285 "gkr-item.c"
}

static void
seahorse_gkr_item_set_secret_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	SeahorseGkrItemSetSecretData* _data_;
#line 245 "../gkr/gkr-item.vala"
	_data_ = _user_data_;
#line 245 "../gkr/gkr-item.vala"
	_data_->_source_object_ = source_object;
#line 245 "../gkr/gkr-item.vala"
	_data_->_res_ = _res_;
#line 245 "../gkr/gkr-item.vala"
	seahorse_gkr_item_set_secret_co (_data_);
#line 1302 "gkr-item.c"
}

static gboolean
seahorse_gkr_item_set_secret_co (SeahorseGkrItemSetSecretData* _data_)
{
#line 243 "../gkr/gkr-item.vala"
	switch (_data_->_state_) {
#line 243 "../gkr/gkr-item.vala"
		case 0:
#line 1312 "gkr-item.c"
		goto _state_0;
#line 243 "../gkr/gkr-item.vala"
		case 1:
#line 1316 "gkr-item.c"
		goto _state_1;
		default:
#line 243 "../gkr/gkr-item.vala"
		g_assert_not_reached ();
#line 1321 "gkr-item.c"
	}
	_state_0:
#line 245 "../gkr/gkr-item.vala"
	_data_->_state_ = 1;
#line 245 "../gkr/gkr-item.vala"
	secret_item_set_secret (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, secret_item_get_type (), SecretItem), _data_->value, _data_->cancellable, seahorse_gkr_item_set_secret_ready, _data_);
#line 245 "../gkr/gkr-item.vala"
	return FALSE;
#line 1330 "gkr-item.c"
	_state_1:
#line 245 "../gkr/gkr-item.vala"
	secret_item_set_secret_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, secret_item_get_type (), SecretItem), _data_->_res_, &_data_->_inner_error0_);
#line 245 "../gkr/gkr-item.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 245 "../gkr/gkr-item.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 245 "../gkr/gkr-item.vala"
		g_object_unref (_data_->_async_result);
#line 245 "../gkr/gkr-item.vala"
		return FALSE;
#line 1342 "gkr-item.c"
	}
#line 246 "../gkr/gkr-item.vala"
	_data_->_tmp0_ = _secret_value_ref0 (_data_->value);
#line 246 "../gkr/gkr-item.vala"
	_secret_value_unref0 (_data_->self->priv->_item_secret);
#line 246 "../gkr/gkr-item.vala"
	_data_->self->priv->_item_secret = _data_->_tmp0_;
#line 247 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) _data_->self, "has-secret");
#line 248 "../gkr/gkr-item.vala"
	_data_->result = TRUE;
#line 248 "../gkr/gkr-item.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 248 "../gkr/gkr-item.vala"
	if (_data_->_state_ != 0) {
#line 248 "../gkr/gkr-item.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 248 "../gkr/gkr-item.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1362 "gkr-item.c"
		}
	}
#line 248 "../gkr/gkr-item.vala"
	g_object_unref (_data_->_async_result);
#line 248 "../gkr/gkr-item.vala"
	return FALSE;
#line 1369 "gkr-item.c"
}

static void
seahorse_gkr_item_copy_secret_to_clipboard_data_free (gpointer _data)
{
	SeahorseGkrItemCopySecretToClipboardData* _data_;
	_data_ = _data;
#line 38 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->clipboard);
#line 38 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../gkr/gkr-item.vala"
	g_slice_free (SeahorseGkrItemCopySecretToClipboardData, _data_);
#line 1383 "gkr-item.c"
}

void
seahorse_gkr_item_copy_secret_to_clipboard (SeahorseGkrItem* self,
                                            GtkClipboard* clipboard,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	SeahorseGkrItemCopySecretToClipboardData* _data_;
	SeahorseGkrItem* _tmp0_;
	GtkClipboard* _tmp1_;
#line 38 "../gkr/gkr-item.vala"
	g_return_if_fail (self != NULL);
#line 38 "../gkr/gkr-item.vala"
	g_return_if_fail (clipboard != NULL);
#line 38 "../gkr/gkr-item.vala"
	_data_ = g_slice_new0 (SeahorseGkrItemCopySecretToClipboardData);
#line 38 "../gkr/gkr-item.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../gkr/gkr-item.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_gkr_item_copy_secret_to_clipboard_data_free);
#line 38 "../gkr/gkr-item.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../gkr/gkr-item.vala"
	_data_->self = _tmp0_;
#line 38 "../gkr/gkr-item.vala"
	_tmp1_ = _g_object_ref0 (clipboard);
#line 38 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->clipboard);
#line 38 "../gkr/gkr-item.vala"
	_data_->clipboard = _tmp1_;
#line 38 "../gkr/gkr-item.vala"
	seahorse_gkr_item_copy_secret_to_clipboard_co (_data_);
#line 1417 "gkr-item.c"
}

void
seahorse_gkr_item_copy_secret_to_clipboard_finish (SeahorseGkrItem* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	SeahorseGkrItemCopySecretToClipboardData* _data_;
#line 38 "../gkr/gkr-item.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 38 "../gkr/gkr-item.vala"
	if (NULL == _data_) {
#line 38 "../gkr/gkr-item.vala"
		return;
#line 1432 "gkr-item.c"
	}
}

static void
seahorse_gkr_item_copy_secret_to_clipboard_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	SeahorseGkrItemCopySecretToClipboardData* _data_;
#line 253 "../gkr/gkr-item.vala"
	_data_ = _user_data_;
#line 253 "../gkr/gkr-item.vala"
	_data_->_source_object_ = source_object;
#line 253 "../gkr/gkr-item.vala"
	_data_->_res_ = _res_;
#line 253 "../gkr/gkr-item.vala"
	seahorse_gkr_item_copy_secret_to_clipboard_co (_data_);
#line 1450 "gkr-item.c"
}

static gboolean
seahorse_gkr_item_copy_secret_to_clipboard_co (SeahorseGkrItemCopySecretToClipboardData* _data_)
{
#line 251 "../gkr/gkr-item.vala"
	switch (_data_->_state_) {
#line 251 "../gkr/gkr-item.vala"
		case 0:
#line 1460 "gkr-item.c"
		goto _state_0;
#line 251 "../gkr/gkr-item.vala"
		case 1:
#line 1464 "gkr-item.c"
		goto _state_1;
		default:
#line 251 "../gkr/gkr-item.vala"
		g_assert_not_reached ();
#line 1469 "gkr-item.c"
	}
	_state_0:
#line 252 "../gkr/gkr-item.vala"
	_data_->_tmp0_ = _data_->self->priv->_item_secret;
#line 252 "../gkr/gkr-item.vala"
	if (_data_->_tmp0_ == NULL) {
#line 253 "../gkr/gkr-item.vala"
		_data_->_state_ = 1;
#line 253 "../gkr/gkr-item.vala"
		seahorse_gkr_item_load_item_secret (_data_->self, seahorse_gkr_item_copy_secret_to_clipboard_ready, _data_);
#line 253 "../gkr/gkr-item.vala"
		return FALSE;
#line 1482 "gkr-item.c"
		_state_1:
#line 253 "../gkr/gkr-item.vala"
		seahorse_gkr_item_load_item_secret_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 253 "../gkr/gkr-item.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 253 "../gkr/gkr-item.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 253 "../gkr/gkr-item.vala"
			g_object_unref (_data_->_async_result);
#line 253 "../gkr/gkr-item.vala"
			return FALSE;
#line 1494 "gkr-item.c"
		}
	}
#line 255 "../gkr/gkr-item.vala"
	_data_->_tmp1_ = _data_->self->priv->_item_secret;
#line 255 "../gkr/gkr-item.vala"
	if (_data_->_tmp1_ == NULL) {
#line 256 "../gkr/gkr-item.vala"
		g_debug ("gkr-item.vala:256: Can't copy to clipboard: secret is NULL");
#line 257 "../gkr/gkr-item.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 257 "../gkr/gkr-item.vala"
		if (_data_->_state_ != 0) {
#line 257 "../gkr/gkr-item.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 257 "../gkr/gkr-item.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1511 "gkr-item.c"
			}
		}
#line 257 "../gkr/gkr-item.vala"
		g_object_unref (_data_->_async_result);
#line 257 "../gkr/gkr-item.vala"
		return FALSE;
#line 1518 "gkr-item.c"
	}
#line 260 "../gkr/gkr-item.vala"
	_data_->_tmp2_ = _data_->self->priv->_item_secret;
#line 260 "../gkr/gkr-item.vala"
	_data_->_tmp3_ = secret_value_get_text (_data_->_tmp2_);
#line 260 "../gkr/gkr-item.vala"
	_data_->password = _data_->_tmp3_;
#line 261 "../gkr/gkr-item.vala"
	_data_->_tmp4_ = _data_->password;
#line 261 "../gkr/gkr-item.vala"
	if (_data_->_tmp4_ == NULL) {
#line 262 "../gkr/gkr-item.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 262 "../gkr/gkr-item.vala"
		if (_data_->_state_ != 0) {
#line 262 "../gkr/gkr-item.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 262 "../gkr/gkr-item.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1538 "gkr-item.c"
			}
		}
#line 262 "../gkr/gkr-item.vala"
		g_object_unref (_data_->_async_result);
#line 262 "../gkr/gkr-item.vala"
		return FALSE;
#line 1545 "gkr-item.c"
	}
#line 264 "../gkr/gkr-item.vala"
	_data_->_tmp5_ = _data_->password;
#line 264 "../gkr/gkr-item.vala"
	gtk_clipboard_set_text (_data_->clipboard, _data_->_tmp5_, -1);
#line 265 "../gkr/gkr-item.vala"
	g_debug ("gkr-item.vala:265: Succesfully copied secret to clipboard");
#line 251 "../gkr/gkr-item.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 251 "../gkr/gkr-item.vala"
	if (_data_->_state_ != 0) {
#line 251 "../gkr/gkr-item.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 251 "../gkr/gkr-item.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1561 "gkr-item.c"
		}
	}
#line 251 "../gkr/gkr-item.vala"
	g_object_unref (_data_->_async_result);
#line 251 "../gkr/gkr-item.vala"
	return FALSE;
#line 1568 "gkr-item.c"
}

SeahorseGkrItem*
seahorse_gkr_item_construct (GType object_type)
{
	SeahorseGkrItem * self = NULL;
#line 38 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItem*) g_object_new (object_type, NULL);
#line 38 "../gkr/gkr-item.vala"
	return self;
#line 1579 "gkr-item.c"
}

SeahorseGkrItem*
seahorse_gkr_item_new (void)
{
#line 38 "../gkr/gkr-item.vala"
	return seahorse_gkr_item_construct (SEAHORSE_GKR_TYPE_ITEM);
#line 1587 "gkr-item.c"
}

gchar*
seahorse_gkr_item_get_description (SeahorseGkrItem* self)
{
	gchar* result;
	SeahorseGkrItemInfo* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 41 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../gkr/gkr-item.vala"
	seahorse_gkr_item_ensure_item_info (self);
#line 43 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_info;
#line 43 "../gkr/gkr-item.vala"
	_tmp1_ = seahorse_gkr_item_info_get_description (_tmp0_);
#line 43 "../gkr/gkr-item.vala"
	_tmp2_ = _tmp1_;
#line 43 "../gkr/gkr-item.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 43 "../gkr/gkr-item.vala"
	result = _tmp3_;
#line 43 "../gkr/gkr-item.vala"
	return result;
#line 1614 "gkr-item.c"
}

SeahorseGkrUse
seahorse_gkr_item_get_use (SeahorseGkrItem* self)
{
	SeahorseGkrUse result;
	gchar* schema_name = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 48 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "../gkr/gkr-item.vala"
	_tmp0_ = seahorse_gkr_item_get_attribute (self, "xdg:schema");
#line 49 "../gkr/gkr-item.vala"
	schema_name = _tmp0_;
#line 50 "../gkr/gkr-item.vala"
	_tmp2_ = schema_name;
#line 50 "../gkr/gkr-item.vala"
	if (_tmp2_ != NULL) {
#line 1635 "gkr-item.c"
		const gchar* _tmp3_;
#line 50 "../gkr/gkr-item.vala"
		_tmp3_ = schema_name;
#line 50 "../gkr/gkr-item.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, SEAHORSE_GKR_NETWORK_PASSWORD) == 0;
#line 1641 "gkr-item.c"
	} else {
#line 50 "../gkr/gkr-item.vala"
		_tmp1_ = FALSE;
#line 1645 "gkr-item.c"
	}
#line 50 "../gkr/gkr-item.vala"
	if (_tmp1_) {
#line 51 "../gkr/gkr-item.vala"
		result = SEAHORSE_GKR_USE_NETWORK;
#line 51 "../gkr/gkr-item.vala"
		_g_free0 (schema_name);
#line 51 "../gkr/gkr-item.vala"
		return result;
#line 1655 "gkr-item.c"
	}
#line 52 "../gkr/gkr-item.vala"
	result = SEAHORSE_GKR_USE_OTHER;
#line 52 "../gkr/gkr-item.vala"
	_g_free0 (schema_name);
#line 52 "../gkr/gkr-item.vala"
	return result;
#line 1663 "gkr-item.c"
}

gboolean
seahorse_gkr_item_get_has_secret (SeahorseGkrItem* self)
{
	gboolean result;
	SecretValue* _tmp0_;
#line 57 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_item_secret;
#line 57 "../gkr/gkr-item.vala"
	result = _tmp0_ != NULL;
#line 57 "../gkr/gkr-item.vala"
	return result;
#line 1679 "gkr-item.c"
}

SeahorseGkrKeyring*
seahorse_gkr_item_get_place (SeahorseGkrItem* self)
{
	SeahorseGkrKeyring* result;
	GObject* _tmp0_;
#line 61 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../gkr/gkr-item.vala"
	_tmp0_ = g_weak_ref_get (&self->priv->_place);
#line 61 "../gkr/gkr-item.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SEAHORSE_GKR_TYPE_KEYRING, SeahorseGkrKeyring);
#line 61 "../gkr/gkr-item.vala"
	return result;
#line 1695 "gkr-item.c"
}

void
seahorse_gkr_item_set_place (SeahorseGkrItem* self,
                             SeahorseGkrKeyring* value)
{
#line 62 "../gkr/gkr-item.vala"
	g_return_if_fail (self != NULL);
#line 62 "../gkr/gkr-item.vala"
	g_weak_ref_set (&self->priv->_place, (GObject*) value);
#line 62 "../gkr/gkr-item.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_PLACE_PROPERTY]);
#line 1708 "gkr-item.c"
}

SeahorseFlags
seahorse_gkr_item_get_object_flags (SeahorseGkrItem* self)
{
	SeahorseFlags result;
#line 66 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 66 "../gkr/gkr-item.vala"
	result = SEAHORSE_FLAG_DELETABLE | SEAHORSE_FLAG_PERSONAL;
#line 66 "../gkr/gkr-item.vala"
	return result;
#line 1721 "gkr-item.c"
}

GIcon*
seahorse_gkr_item_get_icon (SeahorseGkrItem* self)
{
	GIcon* result;
	GIcon* _tmp0_ = NULL;
	SeahorseGkrItemInfo* _tmp1_;
	GIcon* _tmp2_;
	GIcon* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp6_;
#line 70 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../gkr/gkr-item.vala"
	seahorse_gkr_item_ensure_item_info (self);
#line 72 "../gkr/gkr-item.vala"
	_tmp1_ = self->priv->_info;
#line 72 "../gkr/gkr-item.vala"
	_tmp2_ = seahorse_gkr_item_info_get_icon (_tmp1_);
#line 72 "../gkr/gkr-item.vala"
	_tmp3_ = _tmp2_;
#line 72 "../gkr/gkr-item.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 72 "../gkr/gkr-item.vala"
	_tmp0_ = _tmp4_;
#line 72 "../gkr/gkr-item.vala"
	if (_tmp0_ == NULL) {
#line 1750 "gkr-item.c"
		GThemedIcon* _tmp5_;
#line 72 "../gkr/gkr-item.vala"
		_tmp5_ = (GThemedIcon*) g_themed_icon_new (SEAHORSE_ICON_PASSWORD);
#line 72 "../gkr/gkr-item.vala"
		_g_object_unref0 (_tmp0_);
#line 72 "../gkr/gkr-item.vala"
		_tmp0_ = (GIcon*) _tmp5_;
#line 1758 "gkr-item.c"
	}
#line 72 "../gkr/gkr-item.vala"
	_tmp6_ = _tmp0_;
#line 72 "../gkr/gkr-item.vala"
	_tmp0_ = NULL;
#line 72 "../gkr/gkr-item.vala"
	result = _tmp6_;
#line 72 "../gkr/gkr-item.vala"
	_g_object_unref0 (_tmp0_);
#line 72 "../gkr/gkr-item.vala"
	return result;
#line 1770 "gkr-item.c"
}

gchar*
seahorse_gkr_item_get_label (SeahorseGkrItem* self)
{
	gchar* result;
	SeahorseGkrItemInfo* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 77 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../gkr/gkr-item.vala"
	seahorse_gkr_item_ensure_item_info (self);
#line 79 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_info;
#line 79 "../gkr/gkr-item.vala"
	_tmp1_ = seahorse_gkr_item_info_get_label (_tmp0_);
#line 79 "../gkr/gkr-item.vala"
	_tmp2_ = _tmp1_;
#line 79 "../gkr/gkr-item.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 79 "../gkr/gkr-item.vala"
	result = _tmp3_;
#line 79 "../gkr/gkr-item.vala"
	return result;
#line 1797 "gkr-item.c"
}

gchar*
seahorse_gkr_item_get_markup (SeahorseGkrItem* self)
{
	gchar* result;
	GString* _result_ = NULL;
	GString* _tmp0_;
	const gchar* _tmp1_ = NULL;
	SeahorseGkrItemInfo* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GString* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	SeahorseGkrItemInfo* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GString* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
#line 84 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../gkr/gkr-item.vala"
	seahorse_gkr_item_ensure_item_info (self);
#line 86 "../gkr/gkr-item.vala"
	_tmp0_ = g_string_new ("");
#line 86 "../gkr/gkr-item.vala"
	_result_ = _tmp0_;
#line 87 "../gkr/gkr-item.vala"
	_tmp2_ = self->priv->_info;
#line 87 "../gkr/gkr-item.vala"
	_tmp3_ = seahorse_gkr_item_info_get_label (_tmp2_);
#line 87 "../gkr/gkr-item.vala"
	_tmp4_ = _tmp3_;
#line 87 "../gkr/gkr-item.vala"
	_tmp1_ = _tmp4_;
#line 87 "../gkr/gkr-item.vala"
	if (_tmp1_ == NULL) {
#line 87 "../gkr/gkr-item.vala"
		_tmp1_ = "";
#line 1840 "gkr-item.c"
	}
#line 87 "../gkr/gkr-item.vala"
	_tmp5_ = _result_;
#line 87 "../gkr/gkr-item.vala"
	_tmp6_ = g_markup_escape_text (_tmp1_, (gssize) -1);
#line 87 "../gkr/gkr-item.vala"
	_tmp7_ = _tmp6_;
#line 87 "../gkr/gkr-item.vala"
	g_string_append (_tmp5_, _tmp7_);
#line 87 "../gkr/gkr-item.vala"
	_g_free0 (_tmp7_);
#line 88 "../gkr/gkr-item.vala"
	_tmp9_ = self->priv->_info;
#line 88 "../gkr/gkr-item.vala"
	_tmp10_ = seahorse_gkr_item_info_get_details (_tmp9_);
#line 88 "../gkr/gkr-item.vala"
	_tmp11_ = _tmp10_;
#line 88 "../gkr/gkr-item.vala"
	if (_tmp11_ != NULL) {
#line 1860 "gkr-item.c"
		SeahorseGkrItemInfo* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 88 "../gkr/gkr-item.vala"
		_tmp12_ = self->priv->_info;
#line 88 "../gkr/gkr-item.vala"
		_tmp13_ = seahorse_gkr_item_info_get_details (_tmp12_);
#line 88 "../gkr/gkr-item.vala"
		_tmp14_ = _tmp13_;
#line 88 "../gkr/gkr-item.vala"
		_tmp8_ = g_strcmp0 (_tmp14_, "") != 0;
#line 1872 "gkr-item.c"
	} else {
#line 88 "../gkr/gkr-item.vala"
		_tmp8_ = FALSE;
#line 1876 "gkr-item.c"
	}
#line 88 "../gkr/gkr-item.vala"
	if (_tmp8_) {
#line 1880 "gkr-item.c"
		GString* _tmp15_;
		GString* _tmp16_;
		SeahorseGkrItemInfo* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		GString* _tmp20_;
#line 89 "../gkr/gkr-item.vala"
		_tmp15_ = _result_;
#line 89 "../gkr/gkr-item.vala"
		g_string_append (_tmp15_, "<span size='small' rise='0' foreground='#555555'>\n");
#line 90 "../gkr/gkr-item.vala"
		_tmp16_ = _result_;
#line 90 "../gkr/gkr-item.vala"
		_tmp17_ = self->priv->_info;
#line 90 "../gkr/gkr-item.vala"
		_tmp18_ = seahorse_gkr_item_info_get_details (_tmp17_);
#line 90 "../gkr/gkr-item.vala"
		_tmp19_ = _tmp18_;
#line 90 "../gkr/gkr-item.vala"
		g_string_append (_tmp16_, _tmp19_);
#line 91 "../gkr/gkr-item.vala"
		_tmp20_ = _result_;
#line 91 "../gkr/gkr-item.vala"
		g_string_append (_tmp20_, "</span>");
#line 1905 "gkr-item.c"
	}
#line 93 "../gkr/gkr-item.vala"
	_tmp21_ = _result_;
#line 93 "../gkr/gkr-item.vala"
	_tmp22_ = _tmp21_->str;
#line 93 "../gkr/gkr-item.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 93 "../gkr/gkr-item.vala"
	result = _tmp23_;
#line 93 "../gkr/gkr-item.vala"
	_g_string_free0 (_result_);
#line 93 "../gkr/gkr-item.vala"
	return result;
#line 1919 "gkr-item.c"
}

SeahorseUsage
seahorse_gkr_item_get_usage (SeahorseGkrItem* self)
{
	SeahorseUsage result;
#line 98 "../gkr/gkr-item.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 98 "../gkr/gkr-item.vala"
	result = SEAHORSE_USAGE_CREDENTIALS;
#line 98 "../gkr/gkr-item.vala"
	return result;
#line 1932 "gkr-item.c"
}

static gboolean
seahorse_gkr_item_real_get_deletable (SeahorseDeletable* base)
{
	gboolean result;
	SeahorseGkrItem* self;
#line 102 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItem*) base;
#line 102 "../gkr/gkr-item.vala"
	result = TRUE;
#line 102 "../gkr/gkr-item.vala"
	return result;
#line 1946 "gkr-item.c"
}

static void
_seahorse_gkr_item___lambda12_ (SeahorseGkrItem* self,
                                GVariant* changed_properties,
                                gchar** invalidated_properties)
{
#line 111 "../gkr/gkr-item.vala"
	g_return_if_fail (changed_properties != NULL);
#line 112 "../gkr/gkr-item.vala"
	_g_object_unref0 (self->priv->_info);
#line 112 "../gkr/gkr-item.vala"
	self->priv->_info = NULL;
#line 113 "../gkr/gkr-item.vala"
	g_object_freeze_notify ((GObject*) self);
#line 114 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) self, "has-secret");
#line 115 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) self, "use");
#line 116 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) self, "label");
#line 117 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) self, "icon");
#line 118 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) self, "markup");
#line 119 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) self, "description");
#line 120 "../gkr/gkr-item.vala"
	g_object_notify ((GObject*) self, "object-flags");
#line 121 "../gkr/gkr-item.vala"
	g_object_thaw_notify ((GObject*) self);
#line 1978 "gkr-item.c"
}

static void
__seahorse_gkr_item___lambda12__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                   GVariant* changed_properties,
                                                                   gchar** invalidated_properties,
                                                                   gpointer self)
{
#line 111 "../gkr/gkr-item.vala"
	_seahorse_gkr_item___lambda12_ ((SeahorseGkrItem*) self, changed_properties, invalidated_properties);
#line 1989 "gkr-item.c"
}

static GObject *
seahorse_gkr_item_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseGkrItem * self;
#line 110 "../gkr/gkr-item.vala"
	parent_class = G_OBJECT_CLASS (seahorse_gkr_item_parent_class);
#line 110 "../gkr/gkr-item.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 110 "../gkr/gkr-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_GKR_TYPE_ITEM, SeahorseGkrItem);
#line 111 "../gkr/gkr-item.vala"
	g_signal_connect_object ((GDBusProxy*) self, "g-properties-changed", (GCallback) __seahorse_gkr_item___lambda12__g_dbus_proxy_g_properties_changed, self, 0);
#line 110 "../gkr/gkr-item.vala"
	return obj;
#line 2010 "gkr-item.c"
}

static void
seahorse_gkr_item_class_init (SeahorseGkrItemClass * klass,
                              gpointer klass_data)
{
#line 38 "../gkr/gkr-item.vala"
	seahorse_gkr_item_parent_class = g_type_class_peek_parent (klass);
#line 38 "../gkr/gkr-item.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseGkrItem_private_offset);
#line 38 "../gkr/gkr-item.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) seahorse_gkr_item_real_dispose;
#line 38 "../gkr/gkr-item.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_gkr_item_get_property;
#line 38 "../gkr/gkr-item.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_gkr_item_set_property;
#line 38 "../gkr/gkr-item.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_gkr_item_constructor;
#line 38 "../gkr/gkr-item.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_gkr_item_finalize;
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_DESCRIPTION_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_USE_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_USE_PROPERTY] = g_param_spec_enum ("use", "use", "use", SEAHORSE_GKR_TYPE_USE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_HAS_SECRET_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_HAS_SECRET_PROPERTY] = g_param_spec_boolean ("has-secret", "has-secret", "has-secret", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_PLACE_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_PLACE_PROPERTY] = g_param_spec_object ("place", "place", "place", SEAHORSE_GKR_TYPE_KEYRING, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_OBJECT_FLAGS_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_OBJECT_FLAGS_PROPERTY] = g_param_spec_flags ("object-flags", "object-flags", "object-flags", SEAHORSE_TYPE_FLAGS, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_ICON_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_LABEL_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_MARKUP_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_MARKUP_PROPERTY] = g_param_spec_string ("markup", "markup", "markup", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_USAGE_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_USAGE_PROPERTY] = g_param_spec_enum ("usage", "usage", "usage", SEAHORSE_TYPE_USAGE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../gkr/gkr-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_GKR_ITEM_DELETABLE_PROPERTY, seahorse_gkr_item_properties[SEAHORSE_GKR_ITEM_DELETABLE_PROPERTY] = g_param_spec_boolean ("deletable", "deletable", "deletable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2051 "gkr-item.c"
}

static void
seahorse_gkr_item_seahorse_deletable_interface_init (SeahorseDeletableIface * iface,
                                                     gpointer iface_data)
{
#line 38 "../gkr/gkr-item.vala"
	seahorse_gkr_item_seahorse_deletable_parent_iface = g_type_interface_peek_parent (iface);
#line 38 "../gkr/gkr-item.vala"
	iface->create_deleter = (SeahorseDeleter* (*) (SeahorseDeletable*)) seahorse_gkr_item_real_create_deleter;
#line 38 "../gkr/gkr-item.vala"
	iface->get_deletable = seahorse_gkr_item_real_get_deletable;
#line 2064 "gkr-item.c"
}

static void
seahorse_gkr_item_seahorse_viewable_interface_init (SeahorseViewableIface * iface,
                                                    gpointer iface_data)
{
#line 38 "../gkr/gkr-item.vala"
	seahorse_gkr_item_seahorse_viewable_parent_iface = g_type_interface_peek_parent (iface);
#line 38 "../gkr/gkr-item.vala"
	iface->create_viewer = (GtkWindow* (*) (SeahorseViewable*, GtkWindow*)) seahorse_gkr_item_real_create_viewer;
#line 2075 "gkr-item.c"
}

static void
seahorse_gkr_item_instance_init (SeahorseGkrItem * self,
                                 gpointer klass)
{
#line 38 "../gkr/gkr-item.vala"
	self->priv = seahorse_gkr_item_get_instance_private (self);
#line 105 "../gkr/gkr-item.vala"
	self->priv->_item_secret = NULL;
#line 106 "../gkr/gkr-item.vala"
	self->priv->_info = NULL;
#line 108 "../gkr/gkr-item.vala"
	self->priv->_req_secret = NULL;
#line 2090 "gkr-item.c"
}

static void
seahorse_gkr_item_finalize (GObject * obj)
{
	SeahorseGkrItem * self;
#line 38 "../gkr/gkr-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_GKR_TYPE_ITEM, SeahorseGkrItem);
#line 105 "../gkr/gkr-item.vala"
	_secret_value_unref0 (self->priv->_item_secret);
#line 106 "../gkr/gkr-item.vala"
	_g_object_unref0 (self->priv->_info);
#line 107 "../gkr/gkr-item.vala"
	g_weak_ref_clear (&self->priv->_place);
#line 108 "../gkr/gkr-item.vala"
	_g_object_unref0 (self->priv->_req_secret);
#line 38 "../gkr/gkr-item.vala"
	G_OBJECT_CLASS (seahorse_gkr_item_parent_class)->finalize (obj);
#line 2109 "gkr-item.c"
}

/**
 * The Seahorse-specific class for entries in a libsecret keyring.
 *
 * Since libsecret creates the object for us, we can't really add stuff using a
 * constructor, so to add specific info for certain categories of items, we
 * stuff everything into the {@link ItemInfo} field.
 */
 G_GNUC_NO_INLINE static GType
seahorse_gkr_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseGkrItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_gkr_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseGkrItem), 0, (GInstanceInitFunc) seahorse_gkr_item_instance_init, NULL };
	static const GInterfaceInfo seahorse_deletable_info = { (GInterfaceInitFunc) seahorse_gkr_item_seahorse_deletable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo seahorse_viewable_info = { (GInterfaceInitFunc) seahorse_gkr_item_seahorse_viewable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType seahorse_gkr_item_type_id;
	seahorse_gkr_item_type_id = g_type_register_static (secret_item_get_type (), "SeahorseGkrItem", &g_define_type_info, 0);
	g_type_add_interface_static (seahorse_gkr_item_type_id, SEAHORSE_TYPE_DELETABLE, &seahorse_deletable_info);
	g_type_add_interface_static (seahorse_gkr_item_type_id, SEAHORSE_TYPE_VIEWABLE, &seahorse_viewable_info);
	SeahorseGkrItem_private_offset = g_type_add_instance_private (seahorse_gkr_item_type_id, sizeof (SeahorseGkrItemPrivate));
	return seahorse_gkr_item_type_id;
}

GType
seahorse_gkr_item_get_type (void)
{
	static volatile gsize seahorse_gkr_item_type_id__once = 0;
	if (g_once_init_enter (&seahorse_gkr_item_type_id__once)) {
		GType seahorse_gkr_item_type_id;
		seahorse_gkr_item_type_id = seahorse_gkr_item_get_type_once ();
		g_once_init_leave (&seahorse_gkr_item_type_id__once, seahorse_gkr_item_type_id);
	}
	return seahorse_gkr_item_type_id__once;
}

static void
_vala_seahorse_gkr_item_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	SeahorseGkrItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_GKR_TYPE_ITEM, SeahorseGkrItem);
#line 38 "../gkr/gkr-item.vala"
	switch (property_id) {
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_DESCRIPTION_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_take_string (value, seahorse_gkr_item_get_description (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_USE_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_set_enum (value, seahorse_gkr_item_get_use (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_HAS_SECRET_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_set_boolean (value, seahorse_gkr_item_get_has_secret (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_PLACE_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_take_object (value, seahorse_gkr_item_get_place (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_OBJECT_FLAGS_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_set_flags (value, seahorse_gkr_item_get_object_flags (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_ICON_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_take_object (value, seahorse_gkr_item_get_icon (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_LABEL_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_take_string (value, seahorse_gkr_item_get_label (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_MARKUP_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_take_string (value, seahorse_gkr_item_get_markup (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_USAGE_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_set_enum (value, seahorse_gkr_item_get_usage (self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_DELETABLE_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		g_value_set_boolean (value, seahorse_deletable_get_deletable ((SeahorseDeletable*) self));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 2215 "gkr-item.c"
		default:
#line 38 "../gkr/gkr-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "../gkr/gkr-item.vala"
		break;
#line 2221 "gkr-item.c"
	}
}

static void
_vala_seahorse_gkr_item_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	SeahorseGkrItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_GKR_TYPE_ITEM, SeahorseGkrItem);
#line 38 "../gkr/gkr-item.vala"
	switch (property_id) {
#line 38 "../gkr/gkr-item.vala"
		case SEAHORSE_GKR_ITEM_PLACE_PROPERTY:
#line 38 "../gkr/gkr-item.vala"
		seahorse_gkr_item_set_place (self, g_value_get_object (value));
#line 38 "../gkr/gkr-item.vala"
		break;
#line 2241 "gkr-item.c"
		default:
#line 38 "../gkr/gkr-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "../gkr/gkr-item.vala"
		break;
#line 2247 "gkr-item.c"
	}
}

SeahorseGkrMappingEntry*
seahorse_gkr_mapping_entry_dup (const SeahorseGkrMappingEntry* self)
{
	SeahorseGkrMappingEntry* dup;
#line 284 "../gkr/gkr-item.vala"
	dup = g_new0 (SeahorseGkrMappingEntry, 1);
#line 284 "../gkr/gkr-item.vala"
	memcpy (dup, self, sizeof (SeahorseGkrMappingEntry));
#line 284 "../gkr/gkr-item.vala"
	return dup;
#line 2261 "gkr-item.c"
}

void
seahorse_gkr_mapping_entry_free (SeahorseGkrMappingEntry* self)
{
#line 284 "../gkr/gkr-item.vala"
	g_free (self);
#line 2269 "gkr-item.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_gkr_mapping_entry_get_type_once (void)
{
	GType seahorse_gkr_mapping_entry_type_id;
	seahorse_gkr_mapping_entry_type_id = g_boxed_type_register_static ("SeahorseGkrMappingEntry", (GBoxedCopyFunc) seahorse_gkr_mapping_entry_dup, (GBoxedFreeFunc) seahorse_gkr_mapping_entry_free);
	return seahorse_gkr_mapping_entry_type_id;
}

GType
seahorse_gkr_mapping_entry_get_type (void)
{
	static volatile gsize seahorse_gkr_mapping_entry_type_id__once = 0;
	if (g_once_init_enter (&seahorse_gkr_mapping_entry_type_id__once)) {
		GType seahorse_gkr_mapping_entry_type_id;
		seahorse_gkr_mapping_entry_type_id = seahorse_gkr_mapping_entry_get_type_once ();
		g_once_init_leave (&seahorse_gkr_mapping_entry_type_id__once, seahorse_gkr_mapping_entry_type_id);
	}
	return seahorse_gkr_mapping_entry_type_id__once;
}

const gchar*
seahorse_gkr_map_item_type_to_specific (const gchar* item_type,
                                        GHashTable* attrs)
{
	const gchar* result;
#line 312 "../gkr/gkr-item.vala"
	if (item_type == NULL) {
#line 313 "../gkr/gkr-item.vala"
		result = SEAHORSE_GKR_GENERIC_SECRET;
#line 313 "../gkr/gkr-item.vala"
		return result;
#line 2303 "gkr-item.c"
	}
#line 314 "../gkr/gkr-item.vala"
	if (attrs == NULL) {
#line 315 "../gkr/gkr-item.vala"
		result = item_type;
#line 315 "../gkr/gkr-item.vala"
		return result;
#line 2311 "gkr-item.c"
	}
	{
		SeahorseGkrMappingEntry* mapping_collection = NULL;
		gint mapping_collection_length1 = 0;
		gint _mapping_collection_size_ = 0;
		gint mapping_it = 0;
#line 317 "../gkr/gkr-item.vala"
		mapping_collection = SEAHORSE_GKR_MAPPING_ENTRIES;
#line 317 "../gkr/gkr-item.vala"
		mapping_collection_length1 = G_N_ELEMENTS (SEAHORSE_GKR_MAPPING_ENTRIES);
#line 317 "../gkr/gkr-item.vala"
		for (mapping_it = 0; mapping_it < mapping_collection_length1; mapping_it = mapping_it + 1) {
#line 2324 "gkr-item.c"
			SeahorseGkrMappingEntry mapping = {0};
#line 317 "../gkr/gkr-item.vala"
			mapping = mapping_collection[mapping_it];
#line 2328 "gkr-item.c"
			{
				SeahorseGkrMappingEntry _tmp0_;
				const gchar* _tmp1_;
				SeahorseGkrMappingEntry _tmp2_;
				const gchar* _tmp3_;
				const gchar* value = NULL;
				gboolean _tmp9_ = FALSE;
				const gchar* _tmp10_;
#line 318 "../gkr/gkr-item.vala"
				_tmp0_ = mapping;
#line 318 "../gkr/gkr-item.vala"
				_tmp1_ = _tmp0_.item_type;
#line 318 "../gkr/gkr-item.vala"
				if (g_strcmp0 (item_type, _tmp1_) != 0) {
#line 319 "../gkr/gkr-item.vala"
					continue;
#line 2345 "gkr-item.c"
				}
#line 321 "../gkr/gkr-item.vala"
				_tmp2_ = mapping;
#line 321 "../gkr/gkr-item.vala"
				_tmp3_ = _tmp2_.match_attribute;
#line 321 "../gkr/gkr-item.vala"
				if (_tmp3_ == NULL) {
#line 2353 "gkr-item.c"
					SeahorseGkrMappingEntry _tmp4_;
					const gchar* _tmp5_;
#line 322 "../gkr/gkr-item.vala"
					_tmp4_ = mapping;
#line 322 "../gkr/gkr-item.vala"
					_tmp5_ = _tmp4_.mapped_type;
#line 322 "../gkr/gkr-item.vala"
					result = _tmp5_;
#line 322 "../gkr/gkr-item.vala"
					return result;
#line 2364 "gkr-item.c"
				}
#line 324 "../gkr/gkr-item.vala"
				value = NULL;
#line 325 "../gkr/gkr-item.vala"
				if (attrs != NULL) {
#line 2370 "gkr-item.c"
					SeahorseGkrMappingEntry _tmp6_;
					const gchar* _tmp7_;
					gconstpointer _tmp8_;
#line 326 "../gkr/gkr-item.vala"
					_tmp6_ = mapping;
#line 326 "../gkr/gkr-item.vala"
					_tmp7_ = _tmp6_.match_attribute;
#line 326 "../gkr/gkr-item.vala"
					_tmp8_ = g_hash_table_lookup (attrs, _tmp7_);
#line 326 "../gkr/gkr-item.vala"
					value = (const gchar*) _tmp8_;
#line 2382 "gkr-item.c"
				}
#line 327 "../gkr/gkr-item.vala"
				_tmp10_ = value;
#line 327 "../gkr/gkr-item.vala"
				if (_tmp10_ != NULL) {
#line 2388 "gkr-item.c"
					SeahorseGkrMappingEntry _tmp11_;
					const gchar* _tmp12_;
#line 327 "../gkr/gkr-item.vala"
					_tmp11_ = mapping;
#line 327 "../gkr/gkr-item.vala"
					_tmp12_ = _tmp11_.match_pattern;
#line 327 "../gkr/gkr-item.vala"
					_tmp9_ = _tmp12_ != NULL;
#line 2397 "gkr-item.c"
				} else {
#line 327 "../gkr/gkr-item.vala"
					_tmp9_ = FALSE;
#line 2401 "gkr-item.c"
				}
#line 327 "../gkr/gkr-item.vala"
				if (_tmp9_) {
#line 2405 "gkr-item.c"
					SeahorseGkrMappingEntry _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 328 "../gkr/gkr-item.vala"
					_tmp13_ = mapping;
#line 328 "../gkr/gkr-item.vala"
					_tmp14_ = _tmp13_.match_pattern;
#line 328 "../gkr/gkr-item.vala"
					_tmp15_ = value;
#line 328 "../gkr/gkr-item.vala"
					if (g_pattern_match_simple (_tmp14_, _tmp15_)) {
#line 2417 "gkr-item.c"
						SeahorseGkrMappingEntry _tmp16_;
						const gchar* _tmp17_;
#line 329 "../gkr/gkr-item.vala"
						_tmp16_ = mapping;
#line 329 "../gkr/gkr-item.vala"
						_tmp17_ = _tmp16_.mapped_type;
#line 329 "../gkr/gkr-item.vala"
						result = _tmp17_;
#line 329 "../gkr/gkr-item.vala"
						return result;
#line 2428 "gkr-item.c"
					}
				} else {
					const gchar* _tmp18_;
#line 330 "../gkr/gkr-item.vala"
					_tmp18_ = value;
#line 330 "../gkr/gkr-item.vala"
					if (_tmp18_ != NULL) {
#line 2436 "gkr-item.c"
						SeahorseGkrMappingEntry _tmp19_;
						const gchar* _tmp20_;
#line 331 "../gkr/gkr-item.vala"
						_tmp19_ = mapping;
#line 331 "../gkr/gkr-item.vala"
						_tmp20_ = _tmp19_.mapped_type;
#line 331 "../gkr/gkr-item.vala"
						result = _tmp20_;
#line 331 "../gkr/gkr-item.vala"
						return result;
#line 2447 "gkr-item.c"
					}
				}
			}
		}
	}
#line 335 "../gkr/gkr-item.vala"
	result = item_type;
#line 335 "../gkr/gkr-item.vala"
	return result;
#line 2457 "gkr-item.c"
}

static inline gpointer
seahorse_gkr_item_deleter_get_instance_private (SeahorseGkrItemDeleter* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseGkrItemDeleter_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 339 "../gkr/gkr-item.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2471 "gkr-item.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 339 "../gkr/gkr-item.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2479 "gkr-item.c"
}

static GtkDialog*
seahorse_gkr_item_deleter_real_create_confirm (SeahorseDeleter* base,
                                               GtkWindow* parent)
{
	SeahorseGkrItemDeleter * self;
	guint num = 0U;
	GList* _tmp0_;
	GtkDialog* result;
#line 341 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItemDeleter*) base;
#line 342 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_items;
#line 342 "../gkr/gkr-item.vala"
	num = g_list_length (_tmp0_);
#line 343 "../gkr/gkr-item.vala"
	if (num == ((guint) 1)) {
#line 2498 "gkr-item.c"
		gchar* label = NULL;
		GList* _tmp1_;
		gconstpointer _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		SeahorseDeleteDialog* _tmp6_;
#line 344 "../gkr/gkr-item.vala"
		_tmp1_ = self->priv->_items;
#line 344 "../gkr/gkr-item.vala"
		_tmp2_ = _tmp1_->data;
#line 344 "../gkr/gkr-item.vala"
		g_object_get ((SecretRetrievable*) G_TYPE_CHECK_INSTANCE_CAST ((SeahorseGkrItem*) _tmp2_, secret_item_get_type (), SecretItem), "label", &_tmp3_, NULL);
#line 344 "../gkr/gkr-item.vala"
		_tmp4_ = _tmp3_;
#line 344 "../gkr/gkr-item.vala"
		label = _tmp4_;
#line 345 "../gkr/gkr-item.vala"
		_tmp5_ = label;
#line 345 "../gkr/gkr-item.vala"
		_tmp6_ = (SeahorseDeleteDialog*) seahorse_delete_dialog_new (parent, _ ("Are you sure you want to delete the password “%s”?"), _tmp5_, NULL);
#line 345 "../gkr/gkr-item.vala"
		g_object_ref_sink (_tmp6_);
#line 345 "../gkr/gkr-item.vala"
		result = (GtkDialog*) _tmp6_;
#line 345 "../gkr/gkr-item.vala"
		_g_free0 (label);
#line 345 "../gkr/gkr-item.vala"
		return result;
#line 2528 "gkr-item.c"
	} else {
		SeahorseDeleteDialog* _tmp7_;
#line 347 "../gkr/gkr-item.vala"
		_tmp7_ = (SeahorseDeleteDialog*) seahorse_delete_dialog_new (parent, ngettext ("Are you sure you want to delete %d password?", "Are you sure you want to delete %d passwords?", (gulong) num), num, NULL);
#line 347 "../gkr/gkr-item.vala"
		g_object_ref_sink (_tmp7_);
#line 347 "../gkr/gkr-item.vala"
		result = (GtkDialog*) _tmp7_;
#line 347 "../gkr/gkr-item.vala"
		return result;
#line 2539 "gkr-item.c"
	}
}

SeahorseGkrItemDeleter*
seahorse_gkr_item_deleter_construct (GType object_type,
                                     SeahorseGkrItem* item)
{
	SeahorseGkrItemDeleter * self = NULL;
#line 352 "../gkr/gkr-item.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 352 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItemDeleter*) seahorse_deleter_construct (object_type);
#line 353 "../gkr/gkr-item.vala"
	if (!seahorse_deleter_add_object ((SeahorseDeleter*) self, (GObject*) item)) {
#line 354 "../gkr/gkr-item.vala"
		g_assert_not_reached ();
#line 2556 "gkr-item.c"
	}
#line 352 "../gkr/gkr-item.vala"
	return self;
#line 2560 "gkr-item.c"
}

SeahorseGkrItemDeleter*
seahorse_gkr_item_deleter_new (SeahorseGkrItem* item)
{
#line 352 "../gkr/gkr-item.vala"
	return seahorse_gkr_item_deleter_construct (SEAHORSE_GKR_TYPE_ITEM_DELETER, item);
#line 2568 "gkr-item.c"
}

static GList*
seahorse_gkr_item_deleter_real_get_objects (SeahorseDeleter* base)
{
	SeahorseGkrItemDeleter * self;
	GList* _tmp0_;
	GList* result;
#line 357 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItemDeleter*) base;
#line 358 "../gkr/gkr-item.vala"
	_tmp0_ = self->priv->_items;
#line 358 "../gkr/gkr-item.vala"
	result = _tmp0_;
#line 358 "../gkr/gkr-item.vala"
	return result;
#line 2585 "gkr-item.c"
}

static gboolean
seahorse_gkr_item_deleter_real_add_object (SeahorseDeleter* base,
                                           GObject* obj)
{
	SeahorseGkrItemDeleter * self;
	gboolean result;
#line 361 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItemDeleter*) base;
#line 361 "../gkr/gkr-item.vala"
	g_return_val_if_fail (obj != NULL, FALSE);
#line 362 "../gkr/gkr-item.vala"
	if (SEAHORSE_GKR_IS_ITEM (obj)) {
#line 2600 "gkr-item.c"
		SeahorseGkrItem* _tmp0_;
#line 363 "../gkr/gkr-item.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_GKR_TYPE_ITEM, SeahorseGkrItem));
#line 363 "../gkr/gkr-item.vala"
		self->priv->_items = g_list_append (self->priv->_items, _tmp0_);
#line 364 "../gkr/gkr-item.vala"
		result = TRUE;
#line 364 "../gkr/gkr-item.vala"
		return result;
#line 2610 "gkr-item.c"
	}
#line 366 "../gkr/gkr-item.vala"
	result = FALSE;
#line 366 "../gkr/gkr-item.vala"
	return result;
#line 2616 "gkr-item.c"
}

static void
seahorse_gkr_item_deleter_real_delete_data_free (gpointer _data)
{
	SeahorseGkrItemDeleterDeleteData* _data_;
	_data_ = _data;
#line 338 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->cancellable);
#line 338 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->self);
#line 338 "../gkr/gkr-item.vala"
	g_slice_free (SeahorseGkrItemDeleterDeleteData, _data_);
#line 2630 "gkr-item.c"
}

static void
seahorse_gkr_item_deleter_real_delete (SeahorseDeleter* base,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	SeahorseGkrItemDeleter * self;
	SeahorseGkrItemDeleterDeleteData* _data_;
	SeahorseGkrItemDeleter* _tmp0_;
	GCancellable* _tmp1_;
#line 338 "../gkr/gkr-item.vala"
	self = (SeahorseGkrItemDeleter*) base;
#line 338 "../gkr/gkr-item.vala"
	_data_ = g_slice_new0 (SeahorseGkrItemDeleterDeleteData);
#line 338 "../gkr/gkr-item.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 338 "../gkr/gkr-item.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_gkr_item_deleter_real_delete_data_free);
#line 338 "../gkr/gkr-item.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 338 "../gkr/gkr-item.vala"
	_data_->self = _tmp0_;
#line 338 "../gkr/gkr-item.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 338 "../gkr/gkr-item.vala"
	_g_object_unref0 (_data_->cancellable);
#line 338 "../gkr/gkr-item.vala"
	_data_->cancellable = _tmp1_;
#line 338 "../gkr/gkr-item.vala"
	seahorse_gkr_item_deleter_real_delete_co (_data_);
#line 2663 "gkr-item.c"
}

static gboolean
seahorse_gkr_item_deleter_delete_finish (SeahorseDeleter* base,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	gboolean result;
	SeahorseGkrItemDeleterDeleteData* _data_;
#line 338 "../gkr/gkr-item.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 338 "../gkr/gkr-item.vala"
	if (NULL == _data_) {
#line 2677 "gkr-item.c"
		gboolean _tmp0_ = FALSE;
#line 338 "../gkr/gkr-item.vala"
		return _tmp0_;
#line 2681 "gkr-item.c"
	}
#line 338 "../gkr/gkr-item.vala"
	result = _data_->result;
#line 338 "../gkr/gkr-item.vala"
	return result;
#line 2687 "gkr-item.c"
}

static void
seahorse_gkr_item_deleter_delete_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	SeahorseGkrItemDeleterDeleteData* _data_;
#line 372 "../gkr/gkr-item.vala"
	_data_ = _user_data_;
#line 372 "../gkr/gkr-item.vala"
	_data_->_source_object_ = source_object;
#line 372 "../gkr/gkr-item.vala"
	_data_->_res_ = _res_;
#line 372 "../gkr/gkr-item.vala"
	seahorse_gkr_item_deleter_real_delete_co (_data_);
#line 2704 "gkr-item.c"
}

static gboolean
seahorse_gkr_item_deleter_real_delete_co (SeahorseGkrItemDeleterDeleteData* _data_)
{
#line 369 "../gkr/gkr-item.vala"
	switch (_data_->_state_) {
#line 369 "../gkr/gkr-item.vala"
		case 0:
#line 2714 "gkr-item.c"
		goto _state_0;
#line 369 "../gkr/gkr-item.vala"
		case 1:
#line 2718 "gkr-item.c"
		goto _state_1;
		default:
#line 369 "../gkr/gkr-item.vala"
		g_assert_not_reached ();
#line 2723 "gkr-item.c"
	}
	_state_0:
#line 370 "../gkr/gkr-item.vala"
	_data_->_tmp0_ = _data_->self->priv->_items;
#line 370 "../gkr/gkr-item.vala"
	_data_->_tmp1_ = g_list_copy (_data_->_tmp0_);
#line 370 "../gkr/gkr-item.vala"
	_data_->items = _data_->_tmp1_;
#line 371 "../gkr/gkr-item.vala"
	_data_->_tmp2_ = _data_->items;
#line 2734 "gkr-item.c"
	{
#line 371 "../gkr/gkr-item.vala"
		_data_->item_collection = _data_->_tmp2_;
#line 371 "../gkr/gkr-item.vala"
		for (_data_->item_it = _data_->item_collection; _data_->item_it != NULL; _data_->item_it = _data_->item_it->next) {
#line 371 "../gkr/gkr-item.vala"
			_data_->item = (SeahorseGkrItem*) _data_->item_it->data;
#line 2742 "gkr-item.c"
			{
#line 372 "../gkr/gkr-item.vala"
				_data_->_tmp3_ = _data_->item;
#line 372 "../gkr/gkr-item.vala"
				_data_->_state_ = 1;
#line 372 "../gkr/gkr-item.vala"
				secret_item_delete ((SecretItem*) _data_->_tmp3_, _data_->cancellable, seahorse_gkr_item_deleter_delete_ready, _data_);
#line 372 "../gkr/gkr-item.vala"
				return FALSE;
#line 2752 "gkr-item.c"
				_state_1:
#line 372 "../gkr/gkr-item.vala"
				secret_item_delete_finish ((SecretItem*) _data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 372 "../gkr/gkr-item.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 372 "../gkr/gkr-item.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 372 "../gkr/gkr-item.vala"
					(_data_->items == NULL) ? NULL : (_data_->items = (g_list_free (_data_->items), NULL));
#line 372 "../gkr/gkr-item.vala"
					g_object_unref (_data_->_async_result);
#line 372 "../gkr/gkr-item.vala"
					return FALSE;
#line 2766 "gkr-item.c"
				}
			}
		}
	}
#line 373 "../gkr/gkr-item.vala"
	_data_->result = TRUE;
#line 373 "../gkr/gkr-item.vala"
	(_data_->items == NULL) ? NULL : (_data_->items = (g_list_free (_data_->items), NULL));
#line 373 "../gkr/gkr-item.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 373 "../gkr/gkr-item.vala"
	if (_data_->_state_ != 0) {
#line 373 "../gkr/gkr-item.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 373 "../gkr/gkr-item.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2783 "gkr-item.c"
		}
	}
#line 373 "../gkr/gkr-item.vala"
	g_object_unref (_data_->_async_result);
#line 373 "../gkr/gkr-item.vala"
	return FALSE;
#line 2790 "gkr-item.c"
}

static void
seahorse_gkr_item_deleter_class_init (SeahorseGkrItemDeleterClass * klass,
                                      gpointer klass_data)
{
#line 338 "../gkr/gkr-item.vala"
	seahorse_gkr_item_deleter_parent_class = g_type_class_peek_parent (klass);
#line 338 "../gkr/gkr-item.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseGkrItemDeleter_private_offset);
#line 338 "../gkr/gkr-item.vala"
	((SeahorseDeleterClass *) klass)->create_confirm = (GtkDialog* (*) (SeahorseDeleter*, GtkWindow*)) seahorse_gkr_item_deleter_real_create_confirm;
#line 338 "../gkr/gkr-item.vala"
	((SeahorseDeleterClass *) klass)->get_objects = (GList* (*) (SeahorseDeleter*)) seahorse_gkr_item_deleter_real_get_objects;
#line 338 "../gkr/gkr-item.vala"
	((SeahorseDeleterClass *) klass)->add_object = (gboolean (*) (SeahorseDeleter*, GObject*)) seahorse_gkr_item_deleter_real_add_object;
#line 338 "../gkr/gkr-item.vala"
	((SeahorseDeleterClass *) klass)->delete = (void (*) (SeahorseDeleter*, GCancellable*, GAsyncReadyCallback, gpointer)) seahorse_gkr_item_deleter_real_delete;
#line 338 "../gkr/gkr-item.vala"
	((SeahorseDeleterClass *) klass)->delete_finish = (gboolean (*) (SeahorseDeleter*, GAsyncResult*, GError**)) seahorse_gkr_item_deleter_delete_finish;
#line 338 "../gkr/gkr-item.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_gkr_item_deleter_finalize;
#line 2813 "gkr-item.c"
}

static void
seahorse_gkr_item_deleter_instance_init (SeahorseGkrItemDeleter * self,
                                         gpointer klass)
{
#line 338 "../gkr/gkr-item.vala"
	self->priv = seahorse_gkr_item_deleter_get_instance_private (self);
#line 2822 "gkr-item.c"
}

static void
seahorse_gkr_item_deleter_finalize (GObject * obj)
{
	SeahorseGkrItemDeleter * self;
#line 338 "../gkr/gkr-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_GKR_TYPE_ITEM_DELETER, SeahorseGkrItemDeleter);
#line 339 "../gkr/gkr-item.vala"
	(self->priv->_items == NULL) ? NULL : (self->priv->_items = (_g_list_free__g_object_unref0_ (self->priv->_items), NULL));
#line 338 "../gkr/gkr-item.vala"
	G_OBJECT_CLASS (seahorse_gkr_item_deleter_parent_class)->finalize (obj);
#line 2835 "gkr-item.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_gkr_item_deleter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseGkrItemDeleterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_gkr_item_deleter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseGkrItemDeleter), 0, (GInstanceInitFunc) seahorse_gkr_item_deleter_instance_init, NULL };
	GType seahorse_gkr_item_deleter_type_id;
	seahorse_gkr_item_deleter_type_id = g_type_register_static (SEAHORSE_TYPE_DELETER, "SeahorseGkrItemDeleter", &g_define_type_info, 0);
	SeahorseGkrItemDeleter_private_offset = g_type_add_instance_private (seahorse_gkr_item_deleter_type_id, sizeof (SeahorseGkrItemDeleterPrivate));
	return seahorse_gkr_item_deleter_type_id;
}

GType
seahorse_gkr_item_deleter_get_type (void)
{
	static volatile gsize seahorse_gkr_item_deleter_type_id__once = 0;
	if (g_once_init_enter (&seahorse_gkr_item_deleter_type_id__once)) {
		GType seahorse_gkr_item_deleter_type_id;
		seahorse_gkr_item_deleter_type_id = seahorse_gkr_item_deleter_get_type_once ();
		g_once_init_leave (&seahorse_gkr_item_deleter_type_id__once, seahorse_gkr_item_deleter_type_id);
	}
	return seahorse_gkr_item_deleter_type_id__once;
}

